/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
#ifndef ref_gobjectptr_h
#define ref_gobjectptr_h

/** holds reference to a gobject */
template<typename T>
class ref_gobjectptr
{
public:
	ref_gobjectptr() : m_p(0) {}

	ref_gobjectptr(T* p) :m_p(p) { ref(); }

	~ref_gobjectptr() { unref(); }

	ref_gobjectptr<T>& operator=(T* p) { if (m_p != p) { unref(); m_p = p; ref(); } return *this;}

    T* operator->() const { return m_p; }

    operator bool() const { return m_p;}
    operator T*() const { return m_p;}
	T* ptr() const { return m_p; }

    /** adopt gobject ptr which has been already reffed
     * gobjects are created with ref 1
     */
    ref_gobjectptr<T>& adopt(T* p) { if (m_p != p) { unref(); m_p = p; } return *this;}
private:
	void ref() { if (m_p) g_object_ref(m_p); }
	void unref() { if (m_p) g_object_unref(m_p); m_p=0; }

private:
	ref_gobjectptr(const ref_gobjectptr<T>&);
	ref_gobjectptr<T>& operator=(const ref_gobjectptr<T>&);

	T* m_p;
};

#endif
